package iBus.example.hello;

import iBus.*;
import iBus.exception.*;

/**
 * Hello world example.
 *
 * This is the most simple iBus talker application. All it does is pushing
 * a "hello world" string through a channel
 *
 * <P>Usage: hello_talker
 */
public class hello_talker {

    public static void main(String argv [])
      throws Exception
    {
	// create a message string, a destination URL, a protocol stack
	// for reliable multicast, and a Posting object:
	final String message = "hello world";
	final iBusURL url = iBusURLFactory.create("iBus.example.hello", 
						  "1.0", "/messages");
	final Stack stack = new Stack("Reliable");
	final Posting p = new Posting();
	
	// put the message into the posting:
	p.setLength(1);
	p.setObject(0, message);

	// register this application as a talker for the URL:
	stack.registerTalker(url);

	System.err.println(Application.getAppName() + " is ready.");
	
	// in a loop, push the posting, then wait one second:
	for (;;) {
	    stack.push(url, p);
	    Thread.currentThread().sleep(1000);
	}
    }
}
